/*
    Demonstration of polymorphism.
*/

class Animal
{
  public void talk()
  {
    System.out.println("Animals can't talk.");
  }
}

class Pig extends Animal
{
  public void talk()
  {
   //super.talk();  // BOTH talk() methods really are inside each animal object
    System.out.println("Oink.");
  }
}

class Cow extends Animal
{
  public void talk()
  {
    System.out.println("Moo.");
  }

  // Add a method to class Cow that is not in class Animal.
  public void talk2()
  {
    System.out.println("Moo, moo.");
    //super.talk();  // even this method can call Animal's talk() method
  }
}

class Dog extends Animal
{
  public void talk()
  {
    System.out.println("Woof.");
  }
}


class Cat extends Animal
{
   // cats don't have much to say
}


public class TestAnimals
{
   public static void main(String[] args)
   {
      // Create an array of Animal references.
      Animal[] barnyard = new Animal[5];

      // Fill the array with references to
      // objects that are subclasses of Animal.
      barnyard[0] = new Pig();
      barnyard[1] = new Cow();
      barnyard[2] = new Dog();
      barnyard[3] = new Cow();
      barnyard[4] = new Cat();

      // Loop through the array and access each
      // animal's talk() method polymorphically.
      for (int i = 0; i < barnyard.length; i++)
      {
         barnyard[i].talk();
      }

     // Try making the cow moo twice.
   //barnyard[1].talk2();  // this doesn't work

     // Use a cast (since barnYard[1] really
     // does point to a Cow object)
     ((Cow)barnyard[1]).talk2();
   }
}
